;; Pipes/theme.jl
;; $Id$

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
;;wxh
(let*
    ;; images
;;	10x25
    ((bottom-left-i (make-image "bleft.png"))
     ;; 16x16
     (bottom-right-i (make-image "bright.png"))
  
     (top-left-i (make-image "left.png"))
     ;; 16x16
     (top-right-i (make-image "right.png")
		(make-image "right2.png"))
     ;; 225x15
     (title-i (list (make-image "un.middle.png")
		    (make-image "highlight.middle.png")))

     (hbar-i (make-image "bmiddle.png"))
     (vbar-i (make-image "vbar.png"))

     (bump-right-i (list (make-image "un.right.png")
		(make-image "highlight.right.png")))
     (bump-left-i (list (make-image "un.left.png")
		(make-image "highlight.left.png")))

     ;; 16x16
     (menu-i (list (make-image "un.button.left.png")
		   (make-image "button.left.png")))

     ;; 16x16
     (close-i (list (make-image "un.button.close.png")
		    (make-image "button.close.png")))

     (max-i (list (make-image "un.button.up.png")
			    (make-image "button.up.png") nil
			    (make-image "button.up.png")))

     ;; 17x16
     (icon-i (list (make-image "un.button.down.png")
			   (make-image "button.down.png") nil
			   (make-image "button.down.png")))

     ;; frame definitions

     (frame `(((background . ,menu-i)
	       (right-edge . 70)
	       (top-edge . -25)
	       (class . menu-button))

	       ((background . ,icon-i)
	       (right-edge . 49)
	       (top-edge . -25)
	       (class . iconify-button))

	       ((background . ,max-i)
	       (right-edge . 28)
	       (top-edge . -25)
	       (class . maximize-button))

	      ;; title bar
	      ((background . ,title-i)
	       (foreground . "white")
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 17)
	       (right-edge . 101)
	       (top-edge . -25)
	       (class . title))

	       ((background . ,bump-right-i)
	       (right-edge . 91)
	       (top-edge . -25)
	       (class . title))

	       ((background . ,bump-left-i)
	       (left-edge . 7)
	       (top-edge . -25)
	       (class . title))

	      ;; close button
	      ((background . ,close-i)
	       (right-edge . 7)
	       (top-edge . -25)
	       (class . close-button))

	      ;; left frame
	      ((background . ,vbar-i)
	       (left-edge . -3)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))
	      ;; right frame
	      ((background . ,vbar-i)
	       (right-edge . -3)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))
	      ;; bottom frame
	      ((background . ,hbar-i)
	       (left-edge . 7)
	       (right-edge . 7)
	       (bottom-edge . -6)
	       (class . bottom-border))
	      ;; bottom-left corner
	      ((background . ,bottom-left-i)
	       (left-edge . -3)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))
	      ;; bottom-right corner
	      ((background . ,bottom-right-i)
	       (right-edge . -3)
	       (bottom-edge . -6)
	       (class . bottom-right-corner))
	      ;; top-left corner
	      ((background . ,top-left-i)
	       (left-edge . -3)
	       (top-edge . -25)
	       (class . top-left-corner))
	      ;; top-right corner
	      ((background . ,top-right-i)
	       (right-edge . -3)
	       (top-edge . -25)
	       (class . top-right-corner))))

     (shaped-frame `(((background . ,menu-i)
	       (right-edge . 49)
	       (top-edge . -25)
	       (class . menu-button))

	       ((background . ,icon-i)
	       (right-edge . 28)
	       (top-edge . -25)
	       (class . iconify-button))

;;	       ((background . ,max-i)
;;	       (right-edge . 28)
;;	       (top-edge . -25)
;;	       (class . maximize-button))

	      ;; title bar
	      ((background . ,title-i)
	       (foreground . "white")
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 17)
	       (right-edge . 80)
	       (top-edge . -25)
	       (class . title))

	       ((background . ,bump-right-i)
	       (right-edge . 70)
	       (top-edge . -25)
	       (class . title))

	       ((background . ,bump-left-i)
	       (left-edge . 7)
	       (top-edge . -25)
	       (class . title))

	      ;; close button
	      ((background . ,close-i)
	       (right-edge . 7)
	       (top-edge . -25)
	       (class . close-button))


	      ;; top-left corner
	      ((background . ,top-left-i)
	       (left-edge . -3)
	       (top-edge . -25)
	       (class . top-left-corner))
	      ;; top-right corner
	      ((background . ,top-right-i)
	       (right-edge . -3)
	       (top-edge . -25)
	       (class . top-right-corner))))

     (transient-frame `(((background . ,title-i)
	       (foreground . "white")
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 17)
	       (right-edge . 38)
	       (top-edge . -25)
	       (class . title))

	       ((background . ,bump-right-i)
	       (right-edge . 28)
	       (top-edge . -25)
	       (class . title))

	       ((background . ,bump-left-i)
	       (left-edge . 7)
	       (top-edge . -25)
	       (class . title))

	      ;; close button
	      ((background . ,close-i)
	       (right-edge . 7)
	       (top-edge . -25)
	       (class . close-button))



	      ;; left frame
	      ((background . ,vbar-i)
	       (left-edge . -3)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))
	      ;; right frame
	      ((background . ,vbar-i)
	       (right-edge . -3)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))
	      ;; bottom frame
	      ((background . ,hbar-i)
	       (left-edge . 7)
	       (right-edge . 7)
	       (bottom-edge . -6)
	       (class . bottom-border))
	      ;; bottom-left corner
	      ((background . ,bottom-left-i)
	       (left-edge . -3)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))
	      ;; bottom-right corner
	      ((background . ,bottom-right-i)
	       (right-edge . -3)
	       (bottom-edge . -6)
	       (class . bottom-right-corner))
	      ;; top-left corner
	      ((background . ,top-left-i)
	       (left-edge . -3)
	       (top-edge . -25)
	       (class . top-left-corner))
	      ;; top-right corner
	      ((background . ,top-right-i)
	       (right-edge . -3)
	       (top-edge . -25)
	       (class . top-right-corner))))


     (shaped-transient-frame `(((background . ,title-i)
	       (foreground . "white")
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 17)
	       (right-edge . 38)
	       (top-edge . -25)
	       (class . title))

	       ((background . ,bump-right-i)
	       (right-edge . 28)
	       (top-edge . -25)
	       (class . title))

	       ((background . ,bump-left-i)
	       (left-edge . 7)
	       (top-edge . -25)
	       (class . title)))))


  (add-frame-style 'Pipes
		   (lambda (w type)
		     ;; called to produce a frame definition
		     ;; for window W (of type TYPE)
		     (cond ((eq type 'shaped)
			    shaped-frame)
			   ((eq type 'transient)
			    transient-frame)
			   ((eq type 'shaped-transient)
			    shaped-transient-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame)))))






